<template>
  <dialog-card :title="$t('dialogs.change-password.title')" :actions="getActions()">
    <v-form v-model="isValid">
      <v-text-field
        ref="oldPassword" v-model="oldPassword"
        name="oldPassword" :label="$t('dialogs.change-password.oldPassword')"
        required
        :append-icon="showOldPassword ? 'mdi-eye' : 'mdi-eye-off'"
        :type="showOldPassword ? 'text' : 'password'"
        @click:append="showOldPassword = !showOldPassword"
      />
      <v-text-field
        ref="newPassword" v-model="newPassword"
        name="newPassword" :label="$t('dialogs.change-password.newPassword')"
        required
        :rules="[strength]"
        :append-icon="showNewPassword ? 'mdi-eye' : 'mdi-eye-off'"
        :type="showNewPassword ? 'text' : 'password'"
        @click:append="showNewPassword = !showNewPassword"
        @input="updateConfirmedPassword()"
      />
      <v-text-field
        ref="confirmedPassword" v-model="confirmedPassword"
        name="confirmedPassword" :label="$t('dialogs.change-password.confirmedPassword')"
        required
        :rules="[passwordsMatch]"
        :append-icon="showConfirmedPassword ? 'mdi-eye' : 'mdi-eye-off'"
        :type="showConfirmedPassword ? 'text' : 'password'"
        @click:append="showConfirmedPassword = !showConfirmedPassword"
      />
      <v-alert v-if="serverMessage" type="error">
        {{ serverMessage }}
      </v-alert>
    </v-form>
  </dialog-card>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator';
import type { Client } from '@/client';
import { ClientStatus } from '@/client';

interface VField {
  validate(): void;
}

@Component
export default class ChangePasswordDialog extends Vue {
  loading = false;

  isValid = false;

  showOldPassword = false;

  showNewPassword = false;

  showConfirmedPassword = false;

  oldPassword = '';

  newPassword = '';

  confirmedPassword = '';

  serverMessage: string | null = null;

  getActions() {
    return {
      cancel: {
        text: this.$i18n.t('dialogs.change-password.cancel'),
        handle: this.close,
      },
      login: {
        text: 'Ok',
        disabled: !this.isValid,
        handle: this.changePassword,
      },
    };
  }

  @Prop()
  client!: Client;

  async changePassword(): Promise<boolean> {
    if (!this.client.user) return false;

    const res = await this.client.changePassword(
      this.client.user.name,
      this.oldPassword,
      this.newPassword,
    );

    if (res.isOk()) {
      this.client.user = res.data;
      return true;
    }
    if (res.status === ClientStatus.Unauth) {
      this.serverMessage = this.$i18n.t('dialogs.change-password.unauthError').toString();
    } else if (res.status === ClientStatus.NoResponse) {
      this.serverMessage = this.$i18n.t('dialogs.change-password.serverUnreachable').toString();
    } else {
      this.serverMessage = this.$i18n.t('dialogs.change-password.unknownError').toString();
    }
    return false;
  }

  close() {
    this.$emit('submit', false);
  }

  passwordsMatch() {
    if (this.newPassword !== this.confirmedPassword) return this.$i18n.t('dialogs.change-password.passwordsMustMatch');
    return true;
  }

  strength() {
    if (this.newPassword.length < 8) return this.$i18n.t('dialogs.change-password.tooShortPassword');
    return true;
  }

  updateConfirmedPassword() {
    (this.$refs.confirmedPassword as VField | undefined)?.validate();
  }
}
</script>
